#define GRIDSIZE 9
#define rows 3
#define columns 3
#include<iostream>
#include<cstdlib>
#include<ctime>
#include<cstdio>
using namespace std;
int recursions=0,logictimes=0,correctguesses=0,failed=0,multiple=0,recsolved=0; // not for any one obj => global forced
char linegrid[82];
class sudoku{
public:
int grid[9][9],posbl[9][9][9],np[9][9],points,diffscore;
int is_grid_solved(){
	for(int i=0;i<9;i++){
	for(int j=0;j<9;j++){
		if(grid[i][j]==0){
		return 0;
		}
	}
	}
	return 1;
}
int is_pattern_unsolvable(){
	for(int i=0;i<9;i++){
	for(int j=0;j<9;j++){
		if(np[i][j]==0){
		// Failed Recursion - AND/OR - unsolvable sudoku!
		return 1;
		}
		if(!(np[i][j]>=0 || np[i][j]==-5)){
			cout<<"Fatal Error :<"<<endl;
			exit (0);
		}
	}
	}
	return 0;
}
int checkblanks(){
	int blanks=0;
	for(int i=0;i<9;i++){
	for(int j=0;j<9;j++){
		if(grid[i][j]==0){
			blanks++;
		}
	}
	}
	return (blanks);
}
void updatedependencies(int i,int j,int k){
for(int x=0;x<9;x++){
	if(posbl[x][j][k]!=-1){
	posbl[x][j][k]=-1;
		if(grid[x][j]==0){
			np[x][j]--;
		}
	}
	if(posbl[i][x][k]!=-1){
	posbl[i][x][k]=-1;
		if(grid[i][x]==0){
			np[i][x]--;
		}
	}
}
for(int x=3*(int)(i/3);x<3*(int)(i/3)+3;x++){
for(int y=3*(int)(j/3);y<3*(int)(j/3)+3;y++){
	if(!(x==i && y==j) && posbl[x][y][k]!=-1){
	posbl[x][y][k]=-1;
		if(grid[x][y]==0){
			np[x][y]--;
		}
	}
}
}
}
void initobj(){
char line_sudoku[82];
cout<<"Please input the unsolved sudoku grid in the specified format: "<<endl;
cin>>line_sudoku;
int count=0;
for(int i=0;i<9;i++){
for(int j=0;j<9;j++){
	grid[i][j]=line_sudoku[count++]-48;
		if(!(grid[i][j]>0 && grid[i][j]<10)){
		grid[i][j]=0;
		np[i][j]=9;
			for(int k=0;k<9;k++){
				posbl[i][j][k]=k+1;
			}
		continue;
		}
	np[i][j]=-5;
	updatedependencies(i,j,grid[i][j]-1);
	// IDEALLY FOR DEBUGGING ONLY
	for(int k=0;k<9;k++){
		posbl[i][j][k]=-1;
	} // ALGO DOESN'T REQUIRE THIS
	// IDEALLY FOR DEBUGGING ONLY
}
}
}
int guess(){
	for(int i=0;i<9;i++){
	for(int j=0;j<9;j++){
	if(grid[i][j]==0){
		for(int k=0;k<9;k++){
		if(posbl[i][j][k]!=-1){
		sudoku tmp=*this; // *this implies obj. called answer here!
			tmp.grid[i][j]=posbl[i][j][k];
			tmp.np[i][j]=-5;
			recursions++;
			tmp.updatedependencies(i,j,k);
			tmp.solved();
			//if(multiple==0){
				//cout<<"Logic solving included! "; // HOGWASH! SAME NO. OF RECURSIONS!
				//tmp.printsudoku(); // LAST BLANK ALWAYS SOLVED BY LOGIC
				//*this=tmp;
				//return 1; //NEVER RETURN SUCCESSFUL! => OTHER SOLUTION POSBL CHECKED
			//}
		}
		}
		return 0;
	}
	}
	}
	return 0; // required??
}
int solved(){
	if(is_pattern_unsolvable()){
	return 0;
	}
	logic();
	if(is_pattern_unsolvable()){
	return 0;
	}
	if(is_grid_solved()){
	recsolved=1;
	if(multiple==0){
	int count=0;
	for(int i=0;i<9;i++){
	for(int j=0;j<9;j++){
		linegrid[count++]=grid[i][j]+48;
	}
	}
	linegrid[count/*=81*/]='\0';
	}
	if(multiple+1<501){
	multiple++;
	printsudoku();
	return 1;
	}
	else{
	cout<<"No. of valid possible solutions exceeds 500 :?"<<endl;
	exit (0);
	}
	}
	return guess();
}
void logic(){
logictimes++;
int iterations=0,checktcells=checkblanks();
while(checkblanks()!=0 && iterations<2){ // 100 NOT REQD! WHY EVEN 2? TODO LATER
// .94...13..............76..2.8..1.....32.........2...6.....5.4.......8..7..63.4..8
	for(int i=0;i<GRIDSIZE;i++){
	for(int j=0;j<GRIDSIZE;j++){
		if(grid[i][j]==0){
		checkrc(i,j);
		checkbox(rows*(int)(i/rows),columns*(int)(j/columns),i,j);
		if(np[i][j]==1){
			for(int k=0;k<GRIDSIZE;k++){
				if(posbl[i][j][k]>0){
				grid[i][j]=posbl[i][j][k]; np[i][j]=-5;
				//printactivity(i,j,grid[i][j],1);
				break;
				}
			}
		}
			if(grid[i][j]==0){
			rcnootherposbl(i,j,iterations);
			} // PREVENTS REPETITION
			if(grid[i][j]==0){
			nootherposbl(rows*(int)(i/rows),columns*(int)(j/columns),i,j,iterations);
			} // AGAIN PREVENTS REPETITION
		}
	}
	}
	if(checktcells==checkblanks()){
		//cout<<"No New Values Plugged In!"<<endl<<iterations<<endl<<endl; // DEBUGGING ONLY
		iterations++;
	}
	else{
		iterations=0;
		checktcells=checkblanks();
	}
}

}
void printsudoku(){
for(int i=0;i<9;i++){
	for(int j=0;j<9;j++){
	cout<<grid[i][j];//<<" ";
	}
}
cout<<" - Recursions : "<<recursions<<endl;
}
void decorated_sudoku(){
cout<<endl;
for(int i=0;i<9;i++){
	cout<<"    ";
	for(int j=0;j<3;j++){
	cout<<grid[i][j];
	}
	cout<<" | ";
	for(int j=3;j<6;j++){
	cout<<grid[i][j];
	}
	cout<<" | ";
	for(int j=6;j<9;j++){
	cout<<grid[i][j];
	}
	cout<<endl;
	if(i==2 || i==5){
	cout<<"    ----+-----+----"<<endl;
	}
}
cout<<endl;
//cout<<"Blank cells left at this point are "<<checkblanks()<<endl;
//cout<<" - Recursions : "<<recursions<<endl;
}
void checkrc(int i,int j){
	for(int k=0;k<GRIDSIZE;k++){
	if(posbl[i][j][k]!=-1){
	for(int l=0;l<GRIDSIZE;l++){
		if((posbl[i][j][k]==grid[i][l]) || (posbl[i][j][k]==grid[l][j])){
			posbl[i][j][k]=-1; np[i][j]--;
			if(!(np[i][j]>=0 || np[i][j]==-5)){
				cout<<"Fatal Error :<"<<endl;
				exit (0);
			}
		}
	}
	}
	}
}
void rcnootherposbl(int i,int j,int itr){
	for(int k=0;k<GRIDSIZE;k++){
	if(posbl[i][j][k]>0){
		// row done now
		int flag1=0,flag2=1;
			for(int r=0;r<GRIDSIZE;r++){
				if(grid[i][r]==0 && !(r==j)){
					if(posbl[i][r][k]==-1){
					flag1=1;	// flag1=1 => impossible in blank peers and not present in 3x3 box
					}
					else{			
					flag2=0;	// flag2=0 => unknown state of possibility
					}
				}
			}
		if(flag1==1 && flag2==1){
		grid[i][j]=posbl[i][j][k]; np[i][j]=-5;
		//printactivity(i,j,grid[i][j],2);
		break;
		}
		// column done now
		flag1=0;flag2=1;
			for(int c=0;c<GRIDSIZE;c++){
				if(grid[c][j]==0 && !(c==i)){
					if(posbl[c][j][k]==-1){
					flag1=1;	// flag1=1 => impossible in blank peers and not present in 3x3 box
					}
					else{			
					flag2=0;	// flag2=0 => unknown state of possibility
					}
				}
			}
		if(flag1==1 && flag2==1){
		grid[i][j]=posbl[i][j][k]; np[i][j]=-5;
		//printactivity(i,j,grid[i][j],2);
		break;
		}
	}
	}
}
void checkbox(int istart,int jstart,int i,int j){
	for(int t=0;t<GRIDSIZE;t++){
	if(posbl[i][j][t]!=-1){
		for(int k=istart;k<istart+rows && (posbl[i][j][t]!=-1);k++){
		for(int l=jstart;l<jstart+columns && (posbl[i][j][t]!=-1);l++){
			if(grid[k][l]==posbl[i][j][t]){
				posbl[i][j][t]=-1; np[i][j]--;
				if(!(np[i][j]>=0 || np[i][j]==-5)){
					cout<<"Fatal Error :<"<<endl;
					exit (0);
				}
			}
		}
		}
	}
	}
}
void nootherposbl(int istart,int jstart,int i,int j,int itr){
	for(int k=0;k<GRIDSIZE;k++){
	if(posbl[i][j][k]>0){
		int flag1=0,flag2=1;
		int x=i/rows,y=j/columns;
		istart=x*rows;jstart=y*columns;
			for(int m=istart;m<istart+rows;m++){
			for(int n=jstart;n<jstart+columns;n++){
				if(grid[m][n]==0 && !(m==i && n==j)){
					if(posbl[m][n][k]==-1){
					flag1=1;	// flag1=1 => impossible in blank peers and not present in 3x3 box
					}
					else{			
					flag2=0;	// flag2=0 => unknown state of possibility
					}
				}
			}
			}
		if(flag1==1 && flag2==1){
		grid[i][j]=posbl[i][j][k]; np[i][j]=-5;
		//printactivity(i,j,grid[i][j],3);
		break;
		}
	}
	}
}
void printactivity(int i,int j,int value,int which=0){
/*
which is the identification no. for the logic
1 - RCs+BOXs
2 - NOOTHERPOSBL RC
3 - NOOTHERPOSBL BOX
*/
if(!(which==1 || which==2 || which==3)){
cout<<"Plugged in "<<value<<" at ("<<i+1<<","<<j+1<<")";
}
switch(which){
case 1:
cout<<" by Rows/Columns/Box Elimination"<<endl;
break;
case 2:
cout<<" since nowhere else possible in Rows/Columns"<<endl;
break;
case 3:
cout<<" since nowhere else possible in Box"<<endl;
break;
default:
cout<<"Fatal Error :<"<<endl;
exit (1);
}
//cout<<endl;printsudoku();
}
};
void save_only_solution(){
long int filename=time(NULL);
//cout<<filename<<endl;
FILE *time_sdk;
time_sdk=fopen("solution.txt","w");
if(time_sdk==NULL){
cout<<"Failed to create/write the file "<<filename<<".sdk :("<<endl;
return;// (0);
}
fputs(linegrid,time_sdk);
fclose(time_sdk);
cout<<linegrid<<endl;
cout<<"Unique solution the grid saved in "<<filename<<".sdk"<<endl;
return;// (1);
}
int main(){
	sudoku main;
		main.initobj();
		if(main.is_pattern_unsolvable()){
			cout<<"Invalid sudoku entered..."<<endl;
			return 0; // REMEMBER THAT HERE 0 = FALSE
		}
		cout<<endl<<"Unsolved Grid with "<<main.checkblanks()<<" blanks: "<<endl;
		main.decorated_sudoku();
	sudoku answer=main;
		int debug=answer.solved();
		if(multiple>1 || (recsolved==1 && debug==0)){
			debug=1;
		}
		cout<<"debug:"<<debug<<endl;
		if(multiple>0){
			if(multiple==1){
				cout<<endl<<"Exactly 1 solution found!"<<endl;
				char save;
				cout<<"Save solution in a file? (y/n)"<<endl;
				cin>>save;
				if(save=='y'){
					save_only_solution();
				}
				else if(save!='n'){
					cout<<"Arbit Nonsense!? Not Saving Grid - Copy Manually :}"<<endl;
				}
			}
			else{
				cout<<endl<<multiple<<" solutions found!"<<endl;
			}
		}
		else if(multiple==0){
			cout<<endl<<"No solution found :{"<<endl;
		}
		else{
			cout<<"Fatal Error :<"<<endl;
			return (0);		// REMEMBER THAT HERE 0 = FAILURE
		}
	return (1);		// REMEMBER THAT HERE 1 = SUCCESS
}