using namespace std;
int recursions=0,logictimes=0,diffscore=0,correctguesses=0,failedguesses=0,multiple=0,recsolved=0,no_guessing_reqd=1,is_puzzle_symmetric=1,fnflag=0,invalid_flag=0,difflevel=1,solve_button=0;
char question_linegrid[82],solution_linegrid[82];
// exclusive to gui
void clean_up_global_linegrids(){
	for(int count=0;count<81;count++){
		question_linegrid[count]=48;
		solution_linegrid[count]=48;
	}
	question_linegrid[81]='\0';
	solution_linegrid[81]='\0';
}
class sudoku{
	public:
	int grid[9][9],posbl[9][9][9],np[9][9];
	void logic(){
		logictimes--;
		int iterations=0,checktcells=checkblanks();
		while(checkblanks()!=0 && iterations<2){
			logictimes++;
			for(int i=0;i<9;i++){
			for(int j=0;j<9;j++){
				if(grid[i][j]==0){
				checkrc(i,j);
				checkbox(3*(int)(i/3),3*(int)(j/3),i,j);
				if(np[i][j]==1){
					for(int k=0;k<9;k++){
						if(posbl[i][j][k]>0){
							grid[i][j]=posbl[i][j][k]; np[i][j]=-5;
							updatedependencies(i,j,k);
							//printactivity(i,j,grid[i][j],1);
							break;
						}
					}
				}
					if(grid[i][j]==0){
						rcnootherposbl(i,j,iterations);
					} // PREVENTS REPETITION
					if(grid[i][j]==0){
						nootherposbl(3*(int)(i/3),3*(int)(j/3),i,j,iterations);
					} // AGAIN PREVENTS REPETITION
				}
			}
			}
			if(checktcells==checkblanks()){
				iterations++;
				logictimes+=2;
			}
			else{
				iterations=0;
				checktcells=checkblanks();
			}
		}
	}
	void checkrc(int i,int j){
		for(int k=0;k<9;k++){
			if(posbl[i][j][k]!=-1){
				for(int l=0;l<9;l++){
					if((posbl[i][j][k]==grid[i][l]) || (posbl[i][j][k]==grid[l][j])){
						posbl[i][j][k]=-1; np[i][j]--;
					}
				}
			}
		}
	}
	void rcnootherposbl(int i,int j,int itr){
		for(int k=0;k<9;k++){
			if(posbl[i][j][k]>0){
				// row done now
				int flag1=0,flag2=1;
				for(int r=0;r<9;r++){
					if(grid[i][r]==0 && !(r==j)){
						if(posbl[i][r][k]==-1){
							flag1=1;	// flag1=1 => impossible in blank peers and not present in 3x3 box
						}
						else{			
							flag2=0;	// flag2=0 => unknown state of possibility
						}
					}
				}
				if(flag1==1 && flag2==1){
					grid[i][j]=posbl[i][j][k]; np[i][j]=-5;
					updatedependencies(i,j,k);
					//printactivity(i,j,grid[i][j],2);
					break;
				}
				// column done now
				flag1=0;flag2=1;
				for(int c=0;c<9;c++){
					if(grid[c][j]==0 && !(c==i)){
						if(posbl[c][j][k]==-1){
							flag1=1;	// flag1=1 => impossible in blank peers and not present in 3x3 box
						}
						else{			
							flag2=0;	// flag2=0 => unknown state of possibility
						}
					}
				}
				if(flag1==1 && flag2==1){
					grid[i][j]=posbl[i][j][k]; np[i][j]=-5;
					updatedependencies(i,j,k);
					//printactivity(i,j,grid[i][j],2);
					break;
				}
			}
		}
	}
	void checkbox(int istart,int jstart,int i,int j){
		for(int t=0;t<9;t++){
			if(posbl[i][j][t]!=-1){
				for(int k=istart;k<istart+3 && (posbl[i][j][t]!=-1);k++){
				for(int l=jstart;l<jstart+3 && (posbl[i][j][t]!=-1);l++){
					if(grid[k][l]==posbl[i][j][t]){
						posbl[i][j][t]=-1; np[i][j]--;
					}
				}
				}
			}
		}
	}
	void nootherposbl(int istart,int jstart,int i,int j,int itr){
		for(int k=0;k<9;k++){
			if(posbl[i][j][k]>0){
				int flag1=0,flag2=1;
				int x=i/3,y=j/3;
				istart=x*3;jstart=y*3;
				for(int m=istart;m<istart+3;m++){
				for(int n=jstart;n<jstart+3;n++){
					if(grid[m][n]==0 && !(m==i && n==j)){
						if(posbl[m][n][k]==-1){
						flag1=1;	// flag1=1 => impossible in blank peers and not present in 3x3 box
						}
						else{			
						flag2=0;	// flag2=0 => unknown state of possibility
						}
					}
				}
				}
				if(flag1==1 && flag2==1){
					grid[i][j]=posbl[i][j][k]; np[i][j]=-5;
					updatedependencies(i,j,k);
					//printactivity(i,j,grid[i][j],3);
					break;
				}
			}
		}
	}
	void updatedependencies(int i,int j,int k){
		for(int x=0;x<9;x++){
			if(posbl[x][j][k]!=-1){
			posbl[x][j][k]=-1;
				if(grid[x][j]==0){
					np[x][j]--;
				}
			}
			if(posbl[i][x][k]!=-1){
			posbl[i][x][k]=-1;
				if(grid[i][x]==0){
					np[i][x]--;
				}
			}
		}
		for(int x=3*(int)(i/3);x<3*(int)(i/3)+3;x++){
		for(int y=3*(int)(j/3);y<3*(int)(j/3)+3;y++){
			if(!(x==i && y==j) && posbl[x][y][k]!=-1){
				posbl[x][y][k]=-1;
				if(grid[x][y]==0){
					np[x][y]--;
				}
			}
		}
		}
	}
	void printsudoku(){
		for(int i=0;i<9;i++){
			for(int j=0;j<9;j++){
				cout<<grid[i][j];
			}
		}
		cout<<endl;
	}
	void decorated_sudoku(){
		cout<<"#-----+-----+-----#"<<endl;
		for(int i=0;i<9;i++){
			cout<<"| ";
			for(int j=0;j<3;j++){
				cout<<grid[i][j];
			}
			cout<<" | ";
			for(int j=3;j<6;j++){
				cout<<grid[i][j];
			}
			cout<<" | ";
			for(int j=6;j<9;j++){
				cout<<grid[i][j];
			}
			cout<<" |";
			cout<<endl;
			if(i==2 || i==5){
				cout<<"|-----+-----+-----|"<<endl;
			}
		}
		cout<<"#-----+-----+-----#"<<endl;
	}
	int is_grid_solved(){
		for(int i=0;i<9;i++){
		for(int j=0;j<9;j++){
			if(grid[i][j]==0){
				return 0;
			}
		}
		}
		return 1;
	}
	int is_pattern_unsolvable(){
		for(int i=0;i<9;i++){
		for(int j=0;j<9;j++){
			if(!(np[i][j]>0 || np[i][j]==-5)){
				return (1); // Failed Recursion - AND/OR - unsolvable sudoku!
			}
		}
		}
		if(checkbasicuniqueness()==0 && fnflag==0){
			if(solve_button==1){
				char alert_window_text1[500]="Invalid sudoku entered!",alert_window_text2[500]="(Uniqueness Tests Failed)";
				alert(alert_window_text1,alert_window_text2);
			}
			return (1);
		}
		return (0);
	}
	int checkbasicuniqueness(){
		if(checkblanks()>64 || presentnoscheck()<8){
			return (0);
		}
		return (1);
	}
	int presentnoscheck(){
		int present[9]={0,0,0,0,0,0,0,0,0},presentnos=0;
		for(int i=0;i<9;i++){
		for(int j=0;j<9;j++){
			if(grid[i][j]!=0){
				if(present[(grid[i][j]-1)]!=1){
					present[(grid[i][j]-1)]=1;
					presentnos++;
				}
			}
		}
		}
		return presentnos;
	}
	int checkblanks(){
		int blanks=0;
		for(int i=0;i<9;i++){
		for(int j=0;j<9;j++){
			if(grid[i][j]==0){
				blanks++;
			}
		}
		}
		return (blanks);
	}
	int solved(){
		int guessresult;
		if(is_pattern_unsolvable()){
			return 0;
		}
		logic();
		if(is_pattern_unsolvable()){
			return 0;
		}
		if(fnflag==1){
			if(is_grid_solved()){
				return 1;
			}
			return guess(); // now generator functionality being used // acceptable use of fnflag when merging solver fns
		}
		else if(fnflag==0){
			if(is_grid_solved()){ //printsudoku();
				if(multiple>0){
					multiple++;
					invalid_flag=1;
					return 1;
				}
				else if(multiple==0){
					grid_to_line(grid,solution_linegrid);
					multiple++;
					return (1);
				}
			}
			recsolved=1;
			guessresult=guess(); // now solver functionality being used // acceptable use of fnflag when merging solver fns
			if(guessresult=1){
				correctguesses++;
			}
			else if(guessresult=0){
				failedguesses++;
			}
			return guessresult;
		}
	}
	int guess(){
		for(int i=fnflag;i<9;i++){
		for(int j=0;j<9;j++){
			if(grid[i][j]==0){
				for(int k=0;k<9;k++){
					if(posbl[i][j][k]!=-1){
						sudoku tmp=*this;
						tmp.grid[i][j]=posbl[i][j][k];
						tmp.np[i][j]=-5;
						if(fnflag==0){
							recursions++;
						}
						tmp.updatedependencies(i,j,k);
						if(tmp.solved()){
							if(fnflag==1 || multiple==500){
								*this=tmp; //cout<<"i"<<multiple<<endl;//printsudoku();
								return 1;
							}
						}
					}
				}
				return 0;
			}
		}
		}
		return 0;
	}
	// exclusive to generator
	void initrandobj(){
		for(int i=0;i<9;i++){
		for(int j=0;j<9;j++){
			grid[i][j]=0;
			np[i][j]=9;
				for(int k=0;k<9;k++){
					posbl[i][j][k]=k+1;
				}
		}
		}
		srand(time(NULL));
		for(int i=0,j=0;j<3;j++){
			while(posbl[i][j][(grid[i][j]=(rand()%9+1))-1]==-1);
			np[i][j]=-5;
			updatedependencies(i,j,grid[i][j]-1);
		}
		//srand(time(NULL));
		for(int i=3,j=3;j<6;j++){
			while(posbl[i][j][(grid[i][j]=(rand()%9+1))-1]==-1);
			np[i][j]=-5;
			updatedependencies(i,j,grid[i][j]-1);
		}
		//srand(time(NULL));
		for(int i=6,j=6;j<9;j++){
			while(posbl[i][j][(grid[i][j]=(rand()%9+1))-1]==-1);
			np[i][j]=-5;
			updatedependencies(i,j,grid[i][j]-1);
		}
	}
	int hideblanks(int numblanks){
		fnflag=1; // now generator functionality being used // acceptable use of fnflag when merging solver fns
		sudoku foruser=*this;
		for(int i=0;i<9;i++){
		for(int j=0;j<9;j++){
			if(grid[i][j]!=0){
				for(int k=0;k<9;k++){
					foruser.posbl[i][j][k]=-1;
				}
				foruser.posbl[i][j][(grid[i][j]-1)]=grid[i][j];
				foruser.np[i][j]=-5;
			}
			else{
				for(int k=0;k<9;k++){
					foruser.posbl[i][j][k]=k+1;
				}
				foruser.np[i][j]=9;
			}
		}
		}
		if(is_puzzle_symmetric==1){
			numblanks=(int)(numblanks/2); // symmetrical puzzles only
		}
		for(int a=0;a<numblanks;a++){
			int rem1,rem2; // rem2 for symmetrical puzzles only
			srand(time(NULL));
			int i;
			if(is_puzzle_symmetric==1){
				i=rand()%5; // symmetrical puzzles only
			}
			else{
				i=rand()%9;
			}
			int j=rand()%9;
			if(i==4 && j>4 && is_puzzle_symmetric==1){
				while((j=rand()%9)>4); // symmetrical puzzles only
			}
			while(1){
				if((rem1=foruser.grid[i][j])!=0){
					foruser.grid[i][j]=0;
					if(is_puzzle_symmetric==1){	
						rem2=foruser.grid[8-i][8-j]; // symmetrical puzzles only
						foruser.grid[8-i][8-j]=0; // symmetrical puzzles only
					}
					break;
				}
				else{
					if(is_puzzle_symmetric==1){
						i=rand()%5; // symmetrical puzzles only
					}
					else{
						i=rand()%9;
					}
					j=rand()%9;
					if(i==4 && j>4 && is_puzzle_symmetric==1){
						while(j=rand()%9>4); // symmetrical puzzles only
					}
				}
			}
			recursions=0,logictimes=0,correctguesses=0,failedguesses=0,multiple=0,recsolved=0,invalid_flag=0;
			sudoku tmp=foruser;
			for(int k=0;k<9;k++){
				tmp.posbl[i][j][k]=k+1;
			}
			tmp.np[i][j]=9;
			if(is_puzzle_symmetric==1){
				for(int k=0;k<9;k++){
					tmp.posbl[8-i][8-j][k]=k+1; // symmetrical puzzles only
				}
				tmp.np[8-i][8-j]=9; // symmetrical puzzles only
			}
			fnflag=0;
			tmp.solved(); // now solver functionality being used // acceptable use of fnflag when merging solver fns
			fnflag=1;
			if(multiple>1 || tmp.checkbasicuniqueness()==0){
				foruser.grid[i][j]=rem1; //cout<<"1 (...More...) Failed HideBlanks Operation ;("<<endl;
				if(is_puzzle_symmetric==1){
					foruser.grid[8-i][8-j]=rem2; // symmetrical puzzles only
				} // HENCE BACKTRACKING IS REQUIRED TO JUST PREVIOUS VALID GRID
				a--;
				continue;
			}
			else if(multiple<1){
				return (0);
			}
			else{ // FURTHER PROGRESSING!
				for(int k=0;k<9;k++){
					foruser.posbl[i][j][k]=k+1;
				}
				foruser.np[i][j]=9;
				if(is_puzzle_symmetric==1){
					for(int k=0;k<9;k++){
						foruser.posbl[8-i][8-j][k]=k+1; // symmetrical puzzles only
					}
					foruser.np[8-i][8-j]=9; // symmetrical puzzles only
				}
			}
		}
		recursions=0,logictimes=0,correctguesses=0,failedguesses=0,multiple=0,recsolved=0,invalid_flag=0;
		sudoku check=foruser;
		fnflag=0;
		check.solved(); // now solver functionality being used // acceptable use of fnflag when merging solver fns
		fnflag=1;
		if(multiple==1 && foruser.checkbasicuniqueness()==1){
			if(recursions!=0 || no_guessing_reqd==1){
					/*cout<<"Puzzle Rating: "<<(*/diffscore=(int)((logictimes+failedguesses*4+correctguesses*2)*numblanks/5)/*)<<endl*/;
					//foruser.printsudoku();
					grid_to_line(foruser.grid,question_linegrid);
					return 1;
			}
			else{ //diffscore=((logictimes+failedguesses*5+correctguesses*2)*numblanks/(float)5);//cout<<"Rejected Due To No Recursion Being Required :(\nPuzzle Rating: "<<diffscore<<endl;//foruser.printsudoku();
				return 0;
			}
		}
		else{
		return 0;
		}
	}
	int randnumblanks(){
		int empty;
		srand(time(NULL));
		if(difflevel==2){
			while(1){
				if((empty=((rand()%100)/2+1))>=46){
					return empty;
				}
			}
		}
		else if(difflevel==1){
			while(1){
				if((empty=((rand()%100)/2-4))>=40){
					return empty;
				}
			}
		}
		else if(difflevel==3){
			while(1){
				if((empty=((rand()%100)/2+5))>=51){
					return empty;
				}
			}
		}
		else if(difflevel==4){
			while(1){
				if((empty=((rand()%100)/2+11))>=55){
					return empty;
				}
			}
		}
	}
	// exclusive to solver
	void init_for_solver(char linegrid_to_solve[82]){
		int count=0;
		for(int i=0;i<9;i++){
		for(int j=0;j<9;j++){
			grid[i][j]=linegrid_to_solve[count++]-48;
			if(!(grid[i][j]>0 && grid[i][j]<10)){
				grid[i][j]=0;
				np[i][j]=9;
				for(int k=0;k<9;k++){
					posbl[i][j][k]=k+1;
				}
				continue;
			}
			np[i][j]=-5;
			updatedependencies(i,j,grid[i][j]-1);
		}
		}
	}
	void printactivity(int i,int j,int value,int which=0){
		if(!(which==1 || which==2 || which==3)){
			cout<<"Plugged in "<<value<<" at ("<<i+1<<","<<j+1<<")";
		} // which is the identification no. for the logic: 1 - RCs+BOXs, 2 - NOOTHERPOSBL RC, 3 - NOOTHERPOSBL BOX
		switch(which){
			case 1:
				cout<<" by Rows/Columns/Box Elimination"<<endl;
				break;
			case 2:
				cout<<" since nowhere else possible in Rows/Columns"<<endl;
				break;
			case 3:
				cout<<" since nowhere else possible in Box"<<endl;
				break;
		}
	}
	void line_to_grid(char linegrid[82]){
		int count=0;
		for (int i=0;i<9;i++){
		for (int j=0;j<9;j++){
			grid[i][j]=linegrid[count++]-48;
		}
		}
	}
	void grid_to_line(int grid_to_convert[9][9],char linegrid[82]){
		int count=0;
		for(int i=0;i<9;i++){
		for(int j=0;j<9;j++){
			linegrid[count++]=grid_to_convert[i][j]+48;
		}
		}
		linegrid[count/*=81*/]='\0';
	}
	void init_current_obj(){
		for(int i=0;i<9;i++){
		for(int j=0;j<9;j++){
			grid[i][j]=0;
			np[i][j]=9;
				for(int k=0;k<9;k++){
					posbl[i][j][k]=k+1;
				}
		}
		}
		clean_up_global_linegrids();
	}
};
// exclusive to solver
void try_to_solve(char linegrid_to_solve[82]){
	recursions=0,logictimes=0,correctguesses=0,failedguesses=0,multiple=0,recsolved=0,invalid_flag=0;
	fnflag=0;
	sudoku grid_to_solve;
	grid_to_solve.init_for_solver(linegrid_to_solve);
	if(grid_to_solve.is_pattern_unsolvable()){
		return;
	}
	grid_to_solve.solved(); //cout<<endl<<"Unsolved Grid with "<<grid_to_solve.checkblanks()<<" blanks: "<<endl<<endl; //grid_to_solve.decorated_sudoku(); //cout<<endl;
}
// exclusive to generator
void generate(){
	sudoku new_question;
	int randblanks=new_question.randnumblanks();
	do{
		fnflag=1;
		new_question.initrandobj();
		new_question.solved();
	}while(new_question.checkblanks()!=0);
	while(new_question.hideblanks(randblanks)==0);
}