/*
Please Read:

1.	Try to understand my terminology & program
2.	Pranit you can start your work in void generate(){} which is mentioned below 
3.	Also see that all the changes in this program outside the void generate(){} 
	you make are mentioned as comments so that it would be easily understood
4.	For now use the supplied images for question we'll change them later

*/

#include<iostream>
using namespace std;

#include <ezwin.h>
#include <cassert>
#include <ctime>
#include "rect.h"
#include "bitmap.h"

int cellselection[9][9]; //This is used to ensure which cell is selected
int cellvalues[9][9];    //This is used to store the numbers in cells
int numberselection[9];	 //This is used to ensure which number is selected
 

SimpleWindow w("All Round SUDOKU", 13.0, 13.5, Position(0.0,0.0));
BitMap a(w),a1(w),a2(w),a3(w),a4(w),a5(w),a6(w),a7(w),a8(w),a9(w);


	float stepfn(float a)
	//This is greatest integral function which is used in next steps
	{
	int temp;
	temp=a;
	return temp;
	}

void clear_puzzle(){}
void generate()
{

//Your work space

}







void solve(){}
void check(){}
void print_hint(){}

void gld() //gld is grid_lines_display()
{		
  float gridx=2.0,gridy=2.0;    //here (gridx,gridy) is the left togridx corner of the grid  
 int i;
	for (i=0;i<=9;i++)
	{
		if ((i)%3==0)
		{
		w.RenderLine  (Position(gridx+i,gridy), Position(gridx+i,gridy+9),Black, 0.1);
		w.RenderLine  (Position(gridx,gridy+i), Position(gridx+9,gridy+i),Black, 0.1);
		}

		else
		{
		w.RenderLine  (Position(gridx+i,gridy), Position(gridx+i,gridy+9),Black, 0.0);
		w.RenderLine  (Position(gridx,gridy+i), Position(gridx+9,gridy+i),Black, 0.0);
		}
	}
	for(i=0;i<=9;i++)
	{
		w.RenderLine  (Position(2+i,12.0), Position(2+i,13.0),Black, 0.0);
	}
		w.RenderLine  (Position(2,12.0), Position(11.0,12.0),Black, 0.0);
		w.RenderLine  (Position(2,13.0), Position(11.0,13.0),Black, 0.0);
}
//----------------------------------------------------------------------
int wmouseclick(const Position &p)
{

int temp_x = stepfn(p.GetXDistance());
int temp_y = stepfn(p.GetYDistance());

int i,j;//loop variables
/*
if (( (temp_x>=5.05)&&(temp_x<=6.15) )&&( (temp_y>= 1.05)&&(temp_y<=1.15) )){clear_puzzle();}
if (( (temp_x>=7.05)&&(temp_x<=8.15) )&&( (temp_y>= 1.05)&&(temp_y<=1.15) )){generate();}
if (( (temp_x>=9.05)&&(temp_x<=10.15) )&&( (temp_y>= 1.05)&&(temp_y<=1.15) )){solve();}
if (( (temp_x>=11.05)&&(temp_x<=12.15) )&&( (temp_y>= 1.05)&&(temp_y<=1.15) )){check();}
if (( (temp_x>=13.05)&&(temp_x<=14.15) )&&( (temp_y>= 1.05)&&(temp_y<=1.15) )){print_hint();}
*/

if ( ((temp_x==3)||(temp_x==4))&&((temp_y==0)||(temp_y==1)) )
{
generate();
}

if( ((temp_x>=2)&&(temp_x<=11))&&((temp_y>=2)&&(temp_y<=11)) )
{
	for(i=0;i<9;i++)//This is to store the selected cell in grid
	{	
		for (j=0;j<9;j++)
		{
			if((temp_x==2+i)&&(temp_y==2+j))
				{
				cellselection[i][j]=1;
				}
			else cellselection[i][j]=0;
		}
	}
}

if(temp_y==12)
{	
	for(i=0;i<9;i++)//This is to store which number is selected
	{
		if (temp_x==2+i)
			{
			numberselection[i]=1;
			}
		else numberselection[i]=0;

	}

	for (int k=0;k<9;k++)
	{
	if (numberselection[k]==1)
		{
		for (i=0;i<9;i++)
			{	
			for (j=0;j<9;j++)
				{
				if (cellselection[i][j]==1)
					{
					if(k==0){a1.Load("1.xpm"); a1.SetPosition(Position(2.0+i,2.0+j)); a1.Draw();}
					if(k==1){a2.Load("2.xpm"); a2.SetPosition(Position(2.0+i,2.0+j)); a2.Draw();}
					if(k==2){a3.Load("3.xpm"); a3.SetPosition(Position(2.0+i,2.0+j)); a3.Draw();}
					if(k==3){a4.Load("4.xpm"); a4.SetPosition(Position(2.0+i,2.0+j)); a4.Draw();}
					if(k==4){a5.Load("5.xpm"); a5.SetPosition(Position(2.0+i,2.0+j)); a5.Draw();}
					if(k==5){a6.Load("6.xpm"); a6.SetPosition(Position(2.0+i,2.0+j)); a6.Draw();}
					if(k==6){a7.Load("7.xpm"); a7.SetPosition(Position(2.0+i,2.0+j)); a7.Draw();}
					if(k==7){a8.Load("8.xpm"); a8.SetPosition(Position(2.0+i,2.0+j)); a8.Draw();}
					if(k==8){a9.Load("9.xpm"); a9.SetPosition(Position(2.0+i,2.0+j)); a9.Draw();}
					cellvalues[i][j]=k+1;gld();
					}
				}
			}
		}
	}


}

}
//----------------------------------------------------------------------------

void window_grid_start()
//a 9x9 grid is generated and numbers are shown which are to be clicked for choosing
{
  int i,j;//loop variables
  float gridx=2.0,gridy=2.0;    //here (gridx,gridy) is the left togridx corner of the grid  
  w.Open(); assert( w.GetStatus() == WindowOpen );

for(i=0;i<9;i++)
{	
	for(j=0;j<9;j++)cellselection[i][j]=0;
	numberselection[i]=0;
}

 
//The following steps are for printing numbers
a.Load("1.xpm");a.SetPosition(Position(2.0,12.0)) ;a.Draw();
a.Load("2.xpm");a.SetPosition(Position(3.0,12.0)) ;a.Draw();
a.Load("3.xpm");a.SetPosition(Position(4.0,12.0)) ;a.Draw();
a.Load("4.xpm");a.SetPosition(Position(5.0,12.0)) ;a.Draw();
a.Load("5.xpm");a.SetPosition(Position(6.0,12.0)) ;a.Draw();
a.Load("6.xpm");a.SetPosition(Position(7.0,12.0)) ;a.Draw();
a.Load("7.xpm");a.SetPosition(Position(8.0,12.0)) ;a.Draw();
a.Load("8.xpm");a.SetPosition(Position(9.0,12.0)) ;a.Draw();
a.Load("9.xpm");a.SetPosition(Position(10.0,12.0)) ;a.Draw();

gld();

w.RenderLine  (Position(3.0,0.5), Position(5.0,0.5),Black, 0.0);
w.RenderLine  (Position(3.0,1.5), Position(5.0,1.5),Black, 0.0);
w.RenderLine  (Position(3.0,0.5), Position(3.0,1.5),Black, 0.0);
w.RenderLine  (Position(5.0,0.5), Position(5.0,1.5),Black, 0.0);

w.RenderText(Position(3.0,0.5),Position(5.0,1.5),"Generate",Black);sleep(0);

/*

for (i=0;i<5;i++)
{	j=2*i;
	w.RenderRectangle(Position(5.0+j,1.0), Position(7.0+j,2.0),White, true);
}

w.RenderText(Position(5.0,1.0),Position(7.0,2.0),"Clear",Black);sleep(0);
w.RenderText(Position(9.0,1.0),Position(11.0,2.0),"Solve",Black);sleep(0);
w.RenderText(Position(11.0,1.0),Position(13.0,2.0),"Check",Black);sleep(0);
w.RenderText(Position(13.0,1.0),Position(15.0,2.0),"Hint",Black);sleep(0);
*/

w.SetMouseClickCallback(wmouseclick);

}

//-----------------------------------------------------------------------------

int ApiMain() 
{
window_grid_start();
return 0;
}
