#define GRIDSIZE 9
#define rows 3
#define columns 3
#include<iostream>
#include<cstdlib>
#include<cassert>
#include<ctime>
using namespace std;
int only_one_soln=1,no_guessing_reqd,recursions=0,logictimes=0,diffscore=0,correctguesses=0,failedguesses=0,multiple=0; // not for any one obj => global forced
class sudoku{
public:
int grid[9][9],posbl[9][9][9],np[9][9];//,points;
int is_grid_solved(){
	for(int i=0;i<9;i++){
	for(int j=0;j<9;j++){
		if(grid[i][j]==0){
		return 0;
		}
	}
	}
	return 1;
}
int is_pattern_unsolvable(){
	for(int i=0;i<9;i++){
	for(int j=0;j<9;j++){
		if(np[i][j]==0){
		// Failed Recursion - AND/OR - unsolvable sudoku!
		return 1;
		}
		assert(np[i][j]>=0 || np[i][j]==-5);
	}
	}
	return 0;
}
int checkblanks(){
	int blanks=0;
	for(int i=0;i<9;i++){
	for(int j=0;j<9;j++){
		if(grid[i][j]==0){
		blanks++;
		}
	}
	}
	return (blanks);
}
void updatedependencies(int i,int j,int k){
for(int x=0;x<9;x++){
	if(posbl[x][j][k]!=-1){
	posbl[x][j][k]=-1;
		if(grid[x][j]==0){
		np[x][j]--;
		}
	}
	if(posbl[i][x][k]!=-1){
	posbl[i][x][k]=-1;
		if(grid[i][x]==0){
		np[i][x]--;
		}
	}
}
for(int x=3*(int)(i/3);x<3*(int)(i/3)+3;x++){
for(int y=3*(int)(j/3);y<3*(int)(j/3)+3;y++){
	if(!(x==i && y==j) && posbl[x][y][k]!=-1){
	posbl[x][y][k]=-1;
		if(grid[x][y]==0){
		np[x][y]--;
		}
	}
}
}
}
void initobj(){
for(int i=0;i<9;i++){
for(int j=0;j<9;j++){
	grid[i][j]=0;
	np[i][j]=9;
		for(int k=0;k<9;k++){
		posbl[i][j][k]=k+1;
		}
}
}
srand(time(NULL));
for(int i=0,j=0;j<3;j++){
	while(posbl[i][j][(grid[i][j]=(rand()%9+1))-1]==-1);
	np[i][j]=-5;
	updatedependencies(i,j,grid[i][j]-1);
}
srand(time(NULL));
for(int i=3,j=3;j<6;j++){
	while(posbl[i][j][(grid[i][j]=(rand()%9+1))-1]==-1);
	np[i][j]=-5;
	updatedependencies(i,j,grid[i][j]-1);
}
srand(time(NULL));
for(int i=6,j=6;j<9;j++){
	while(posbl[i][j][(grid[i][j]=(rand()%9+1))-1]==-1);
	np[i][j]=-5;
	updatedependencies(i,j,grid[i][j]-1);
}
}
int checkbasicuniqueness(){
int present[9]={0,0,0,0,0,0,0,0,0},presentnos=0;
for(int i=0;i<9;i++){
for(int j=0;j<9;j++){
	if(present[(grid[i][j]-1)]!=1){
	present[(grid[i][j]-1)]=1;
	presentnos++;
	}
}
}
return presentnos;
}
int hideblanks(int numblanks){
sudoku foruser=*this;
for(int i=0;i<9;i++){
for(int j=0;j<9;j++){
	if(grid[i][j]!=0){
		for(int k=0;k<9;k++){
			foruser.posbl[i][j][k]=-1;
		}
		foruser.posbl[i][j][(grid[i][j]-1)]=grid[i][j];
		foruser.np[i][j]=-5;
	}
	else{
		for(int k=0;k<9;k++){
			foruser.posbl[i][j][k]=k+1;
		}
		foruser.np[i][j]=9;
	}
}
}
for(int a=0;a<(int)(numblanks/2);a++){ // symmetrical puzzles only
	repeat:
	//cout<<" "<<a<<endl; // DEBUGGING
	int rem1,rem2;
	srand(time(NULL));
	// symmetrical puzzles only
	int i=rand()%5;
	int j=rand()%9;
	if(i==4 && j>4){
		while((j=rand()%9)>4);
	}
	while(1){
		if((rem1=foruser.grid[i][j])!=0){
		foruser.grid[i][j]=0;
		// symmetrical puzzles only
		rem2=foruser.grid[8-i][8-j];
		foruser.grid[8-i][8-j]=0;
		break;
		}
		else{
		// symmetrical puzzles only
		i=rand()%5;
		j=rand()%9;
		if(i==4 && j>4){
			while(j=rand()%9>4);
		}
		}
	}
	//if(only_one_soln==1){
	recursions=0,logictimes=0,correctguesses=0,failedguesses=0,multiple=0;
	sudoku tmp=foruser;
	// NECESSARY EXCEPT AT THOSE POSITIONS OF GRID?
	for(int i=0;i<9;i++){
	for(int j=0;j<9;j++){
	if(tmp.grid[i][j]!=0){
		for(int k=0;k<9;k++){
			tmp.posbl[i][j][k]=-1;
		}
		tmp.posbl[i][j][(tmp.grid[i][j]-1)]=tmp.grid[i][j];
		tmp.np[i][j]=-5;
	}
	else{
		for(int k=0;k<9;k++){
			tmp.posbl[i][j][k]=k+1;
		}
		tmp.np[i][j]=9;
	}
	}
	}
	tmp.solver_solved();
	//cout<<multiple<<endl; // DEBUGGING
	if(multiple>1 || tmp.checkbasicuniqueness()<=7){
	//cout<<"1 (...More...) Failed HideBlanks Operation ;("<<endl;
	//foruser.printsudoku();
	foruser.grid[i][j]=rem1;
	foruser.grid[8-i][8-j]=rem2;
	goto repeat;
	}
	else if(multiple<1){
	cout<<"Fatal Error :<"<<endl;
	exit (0);
	}
	else{ // PROGRESSING!
	//cout<<recursions<<" "<<failedguesses<<" "<<correctguesses<<endl;
	//assert(recursions==failedguesses+correctguesses);
	//foruser.printsudoku();
	}
	//}
}
	recursions=0,logictimes=0,correctguesses=0,failedguesses=0,multiple=0;
	sudoku tmp=foruser;
	for(int i=0;i<9;i++){
	for(int j=0;j<9;j++){
	if(tmp.grid[i][j]!=0){
		for(int k=0;k<9;k++){
			tmp.posbl[i][j][k]=-1;
		}
		tmp.posbl[i][j][(tmp.grid[i][j]-1)]=tmp.grid[i][j];
		tmp.np[i][j]=-5;
	}
	else{
		for(int k=0;k<9;k++){
			tmp.posbl[i][j][k]=k+1;
		}
		tmp.np[i][j]=9;
	}
	}
	}
	tmp.solver_solved();
	//cout<<multiple<<endl;
	if(tmp.checkbasicuniqueness()>7){
		if(recursions!=0 || no_guessing_reqd==1){
			//if(multiple==1){
				cout<<"Difficulty Score: "<<(diffscore=(int)((logictimes+failedguesses*4+correctguesses*2)*numblanks/5))<<endl;
				if(recursions!=0){
				cout<<recursions<<" "<<failedguesses<<" "<<correctguesses<<endl;
				}
				assert(recursions==failedguesses+correctguesses);
				//if(diffscore>500000 && diffscore<1500000){
				foruser.printsudoku();
				//cout<<diffscore<<endl;
				return 1;
				//}
			//}
			/*
			else{ // NEVER OCCURS!
			cout<<"Rejected"<<endl<<diffscore<<endl;
			foruser.printsudoku();
			//return 0;
			}
			*/
		}
		else{
		diffscore=(int)((logictimes+failedguesses*4+correctguesses*2)*numblanks/5);
		cout<<"Rejected Due To No Recursions Being Required :(\nDifficulty Score: "<<diffscore<<endl;
		foruser.printsudoku();
		return 0;
		}
	}
	else{ // NEVER REACHED?
	return 0;
	}
}
int guess(){
	for(int i=1;i<9;i++){
	for(int j=0;j<9;j++){
	if(grid[i][j]==0){
		for(int k=0;k<9;k++){
		if(posbl[i][j][k]!=-1){
		sudoku tmp=*this;
			tmp.grid[i][j]=posbl[i][j][k];
			tmp.np[i][j]=-5;
			//recursions++;
			tmp.updatedependencies(i,j,k);
			if(tmp.solved()){
				*this=tmp;
				return 1;
			}
		}
		}
		return 0;
	}
	}
	}
	return 0; // required??
}
int solved(){
	int guessresult;
	if(is_pattern_unsolvable()){
	return 0;
	}
	logic();
	// DEBUGGING MAIN POINT !!
	if(is_pattern_unsolvable()){
	return 0;
	}
	if(is_grid_solved()){
	return 1;
	}
	//guessresult=guess();
	//if(guessresult=1){
	//correctguesses++; // 2x or 4x More Work DEPENDING ON LEVELS OF RECURSION
	//}
	//else{
	//points+=5; // 5x More Work
	//failedguesses++;
	//}
	//return guessresult;
	return guess();
}
int solver_solved(){
	int guessresult;
	if(is_pattern_unsolvable()){
	return 0;
	}
	logic();
	// DEBUGGING MAIN POINT !!
	if(is_pattern_unsolvable()){
	return 0;
	}
	if(is_grid_solved()){
	multiple++;
	return 1;
	}
	guessresult=solver_guess();
	if(guessresult=1){
	correctguesses++; // 2x or 4x More Work DEPENDING ON LEVELS OF RECURSION
	}
	else if(guessresult=0){
	//points+=5; // 5x More Work
	failedguesses++;
	}
	else{
	cout<<"Fatal Error :<"<<endl;
	exit (0);
	}
	return guessresult;
}
int solver_guess(){
	for(int i=0;i<9;i++){
	for(int j=0;j<9;j++){
	if(grid[i][j]==0){
		for(int k=0;k<9;k++){
		if(posbl[i][j][k]!=-1){
		sudoku tmp=*this;
			tmp.grid[i][j]=posbl[i][j][k];
			tmp.np[i][j]=-5;
			recursions++;
			tmp.updatedependencies(i,j,k);
			tmp.solver_solved();
		}
		}
		return 0;
	}
	}
	}
	return 0; // required??
}
void logic(){
logictimes--; //1st Run Not Counted
//logictimes++; //points++; // 1x More Work
int iterations=0,checktcells=checkblanks();
while(checkblanks()!=0 && iterations<2){ // 100 NOT REQD! WHY EVEN 2? TODO LATER
	logictimes++;
	for(int i=0;i<GRIDSIZE;i++){
	for(int j=0;j<GRIDSIZE;j++){
		if(grid[i][j]==0){
		checkrc(i,j);
		checkbox(rows*(int)(i/rows),columns*(int)(j/columns),i,j);
		if(np[i][j]==1){
			for(int k=0;k<GRIDSIZE;k++){
				if(posbl[i][j][k]>0){
				grid[i][j]=posbl[i][j][k]; np[i][j]=-5;
				break;
				}
			}
		}
			if(grid[i][j]==0){
			rcnootherposbl(i,j,iterations);
			} // PREVENTS REPETITION
			if(grid[i][j]==0){
			nootherposbl(rows*(int)(i/rows),columns*(int)(j/columns),i,j,iterations);
			} // AGAIN PREVENTS REPETITION
		}
	}
	}
	if(checktcells==checkblanks()){
		iterations++; //points+=3; // 3x More Work
		logictimes+=2;
	}
	else{
		iterations=0;
		checktcells=checkblanks();
	}
}
}
void printsudoku(){
for(int i=0;i<9;i++){
	for(int j=0;j<9;j++){
		cout<<grid[i][j];//<<" ";
	}
}
cout<<endl;
}
void checkrc(int i,int j){
	for(int k=0;k<GRIDSIZE;k++){
	if(posbl[i][j][k]!=-1){
	for(int l=0;l<GRIDSIZE;l++){
		if((posbl[i][j][k]==grid[i][l]) || (posbl[i][j][k]==grid[l][j])){
			posbl[i][j][k]=-1; np[i][j]--;
			assert(np[i][j]>=0 || np[i][j]==-5);
			}
	}
	}
	}
}
void rcnootherposbl(int i,int j,int itr){
	for(int k=0;k<GRIDSIZE;k++){
	if(posbl[i][j][k]>0){
		// row done now
		int flag1=0,flag2=1;
			for(int r=0;r<GRIDSIZE;r++){
				if(grid[i][r]==0 && !(r==j)){
					if(posbl[i][r][k]==-1){
					flag1=1;	// flag1=1 => impossible in blank peers and not present in 3x3 box
					}
					else{			
					flag2=0;	// flag2=0 => unknown state of possibility
					}
				}
			}
		if(flag1==1 && flag2==1){
		grid[i][j]=posbl[i][j][k]; np[i][j]=-5;
			for(int z=0;z<GRIDSIZE;z++){
			if(z!=k){
				posbl[i][j][z]=-1;
			}
			}
		break;
		}
		// column done now
		flag1=0;flag2=1;
			for(int c=0;c<GRIDSIZE;c++){
				if(grid[c][j]==0 && !(c==i)){
					if(posbl[c][j][k]==-1){
					flag1=1;	// flag1=1 => impossible in blank peers and not present in 3x3 box
					}
					else{			
					flag2=0;	// flag2=0 => unknown state of possibility
					}
				}
			}
		if(flag1==1 && flag2==1){
		grid[i][j]=posbl[i][j][k]; np[i][j]=-5;
		break;
		}
	}
	}
}
void checkbox(int istart,int jstart,int i,int j){
	for(int t=0;t<GRIDSIZE;t++){
	if(posbl[i][j][t]!=-1){
		for(int k=istart;k<istart+rows && (posbl[i][j][t]!=-1);k++){
		for(int l=jstart;l<jstart+columns && (posbl[i][j][t]!=-1);l++){
			if(grid[k][l]==posbl[i][j][t]){
			posbl[i][j][t]=-1; np[i][j]--;
			assert(np[i][j]>=0 || np[i][j]==-5);
			}
		}
		}
	}
	}
}
void nootherposbl(int istart,int jstart,int i,int j,int itr){
	for(int k=0;k<GRIDSIZE;k++){
	if(posbl[i][j][k]>0){
		int flag1=0,flag2=1;
		int x=i/rows,y=j/columns;
		istart=x*rows;jstart=y*columns;
			for(int m=istart;m<istart+rows;m++){
			for(int n=jstart;n<jstart+columns;n++){
				if(grid[m][n]==0 && !(m==i && n==j)){
					if(posbl[m][n][k]==-1){
					flag1=1;	// flag1=1 => impossible in blank peers and not present in 3x3 box
					}
					else{			
					flag2=0;	// flag2=0 => unknown state of possibility
					}
				}
			}
			}
		if(flag1==1 && flag2==1){
		grid[i][j]=posbl[i][j][k]; np[i][j]=-5;
		break;
		}
	}
	}
}
};
int randnumblanks(int difflevel){
int empty;
srand(time(NULL));
if(difflevel==2){
no_guessing_reqd=1;
	while(1){
		if((empty=((rand()%100)/2+1))>=46){
		return empty;
		}
	}
}
else if(difflevel==1){
no_guessing_reqd=0; // NOT 1 HERE ELSE TOO EASY FOR COMFORT
	while(1){
		if((empty=((rand()%100)/2-4))>=40){
		return empty;
		}
	}
}
else if(difflevel==3){
no_guessing_reqd=0;
	while(1){
		if((empty=((rand()%100)/2+5))>=51){
		return empty;
		}
	}
}
else if(difflevel==4){
no_guessing_reqd=0;
	while(1){
		if((empty=((rand()%100)/2+11))>=55){
		return empty;
		}
	}
}
else{
	cout<<"Arbit Nonsense. Unsolvable (!?) 64 Blanks Assumed ( Will Take Hours :< )"<<endl;
	return 64;
}
}
int main(){
	int difflevel,randblanks;//,norehides=0;
	char choice;
		cout<<"1 - Kiddie - 40 to 45 blanks"<<endl<<"2 - Intermediate - 46 to 50 blanks"<<endl;
		cout<<"3 - Quite Tough - 51 to 54 blanks"<<endl<<"4 - Exclusive to Pros - 55 to 60 blanks"<<endl;
		cout<<"Enter the desired difficulty level: "<<endl;
		cin>>difflevel;
		randblanks=randnumblanks(difflevel);
		cout<<"Do you want a single-solution sudoku? (y/n)"<<endl;
		cin>>choice;
		if(choice=='y'){
		only_one_soln=1;
		}
	restart:
	sudoku main;
	main.initobj();
	main.solved();
		if(main.checkblanks()!=0){
		//cout<<"Failed solving... (Very unusual if not unsolvable!)"<<endl;
		//cout<<"Recursions : "<<recursions<<endl;
		goto restart;
		}
	//rehide:
	rehide:
	if(main.hideblanks(randblanks)){
	return (1);		// REMEMBER THAT HERE 1 = SUCCESS
	}
	else{
	//if(norehides<5){
	//norehides++;
	//goto rehide;
	//}
	//else{
	//norehides=0;
	goto rehide;
	//goto restart;
	//}
	}
	return (0);
}
