class sudoku{
	public:
	int grid[9][9],posbl[9][9][9],np[9][9];
	sudoku::void logic(){
		logictimes--;
		int iterations=0,checktcells=checkblanks();
		while(checkblanks()!=0 && iterations<2){
			logictimes++;
			for(int i=0;i<GRIDSIZE;i++){
			for(int j=0;j<GRIDSIZE;j++){
				if(grid[i][j]==0){
				checkrc(i,j);
				checkbox(rows*(int)(i/rows),columns*(int)(j/columns),i,j);
				if(np[i][j]==1){
					for(int k=0;k<GRIDSIZE;k++){
						if(posbl[i][j][k]>0){
							grid[i][j]=posbl[i][j][k]; np[i][j]=-5;
							updatedependencies(i,j,k);
							//printactivity(i,j,grid[i][j],1);
							break;
						}
					}
				}
					if(grid[i][j]==0){
						rcnootherposbl(i,j,iterations);
					} // PREVENTS REPETITION
					if(grid[i][j]==0){
						nootherposbl(rows*(int)(i/rows),columns*(int)(j/columns),i,j,iterations);
					} // AGAIN PREVENTS REPETITION
				}
			}
			}
			if(checktcells==checkblanks()){
				iterations++;
				logictimes+=2;
			}
			else{
				iterations=0;
				checktcells=checkblanks();
			}
		}
	}
	sudoku::void checkrc(int i,int j){
		for(int k=0;k<GRIDSIZE;k++){
			if(posbl[i][j][k]!=-1){
				for(int l=0;l<GRIDSIZE;l++){
					if((posbl[i][j][k]==grid[i][l]) || (posbl[i][j][k]==grid[l][j])){
						posbl[i][j][k]=-1; np[i][j]--;
						if(!(np[i][j]>=0 || np[i][j]==-5)){
							cout<<"Fatal Error :<"<<endl;
							exit (0);
						}
					}
				}
			}
		}
	}
	sudoku::void rcnootherposbl(int i,int j,int itr){
		for(int k=0;k<GRIDSIZE;k++){
			if(posbl[i][j][k]>0){
				// row done now
				int flag1=0,flag2=1;
				for(int r=0;r<GRIDSIZE;r++){
					if(grid[i][r]==0 && !(r==j)){
						if(posbl[i][r][k]==-1){
							flag1=1;	// flag1=1 => impossible in blank peers and not present in 3x3 box
						}
						else{			
							flag2=0;	// flag2=0 => unknown state of possibility
						}
					}
				}
				if(flag1==1 && flag2==1){
					grid[i][j]=posbl[i][j][k]; np[i][j]=-5;
					updatedependencies(i,j,k);
					//printactivity(i,j,grid[i][j],2);
					break;
				}
				// column done now
				flag1=0;flag2=1;
				for(int c=0;c<GRIDSIZE;c++){
					if(grid[c][j]==0 && !(c==i)){
						if(posbl[c][j][k]==-1){
							flag1=1;	// flag1=1 => impossible in blank peers and not present in 3x3 box
						}
						else{			
							flag2=0;	// flag2=0 => unknown state of possibility
						}
					}
				}
				if(flag1==1 && flag2==1){
					grid[i][j]=posbl[i][j][k]; np[i][j]=-5;
					updatedependencies(i,j,k);
					//printactivity(i,j,grid[i][j],2);
					break;
				}
			}
		}
	}
	sudoku::void checkbox(int istart,int jstart,int i,int j){
		for(int t=0;t<GRIDSIZE;t++){
			if(posbl[i][j][t]!=-1){
				for(int k=istart;k<istart+rows && (posbl[i][j][t]!=-1);k++){
				for(int l=jstart;l<jstart+columns && (posbl[i][j][t]!=-1);l++){
					if(grid[k][l]==posbl[i][j][t]){
						posbl[i][j][t]=-1; np[i][j]--;
						if(!(np[i][j]>=0 || np[i][j]==-5)){
							cout<<"Fatal Error :<"<<endl;
							exit (0);
						}
					}
				}
				}
			}
		}
	}
	sudoku::void nootherposbl(int istart,int jstart,int i,int j,int itr){
		for(int k=0;k<GRIDSIZE;k++){
			if(posbl[i][j][k]>0){
				int flag1=0,flag2=1;
				int x=i/rows,y=j/columns;
				istart=x*rows;jstart=y*columns;
				for(int m=istart;m<istart+rows;m++){
				for(int n=jstart;n<jstart+columns;n++){
					if(grid[m][n]==0 && !(m==i && n==j)){
						if(posbl[m][n][k]==-1){
						flag1=1;	// flag1=1 => impossible in blank peers and not present in 3x3 box
						}
						else{			
						flag2=0;	// flag2=0 => unknown state of possibility
						}
					}
				}
				}
				if(flag1==1 && flag2==1){
					grid[i][j]=posbl[i][j][k]; np[i][j]=-5;
					updatedependencies(i,j,k);
					//printactivity(i,j,grid[i][j],3);
					break;
				}
			}
		}
	}
	sudoku::void updatedependencies(int i,int j,int k){
		for(int x=0;x<9;x++){
			if(posbl[x][j][k]!=-1){
			posbl[x][j][k]=-1;
				if(grid[x][j]==0){
					np[x][j]--;
				}
			}
			if(posbl[i][x][k]!=-1){
			posbl[i][x][k]=-1;
				if(grid[i][x]==0){
					np[i][x]--;
				}
			}
		}
		for(int x=3*(int)(i/3);x<3*(int)(i/3)+3;x++){
		for(int y=3*(int)(j/3);y<3*(int)(j/3)+3;y++){
			if(!(x==i && y==j) && posbl[x][y][k]!=-1){
				posbl[x][y][k]=-1;
				if(grid[x][y]==0){
					np[x][y]--;
				}
			}
		}
		}
	}
	sudoku::void printsudoku(){
		for(int i=0;i<9;i++){
			for(int j=0;j<9;j++){
				cout<<grid[i][j];
			}
		}
	}
	sudoku::void decorated_sudoku(){
		for(int i=0;i<9;i++){
			cout<<"    ";
			for(int j=0;j<3;j++){
			cout<<grid[i][j];
			}
			cout<<" | ";
			for(int j=3;j<6;j++){
			cout<<grid[i][j];
			}
			cout<<" | ";
			for(int j=6;j<9;j++){
			cout<<grid[i][j];
			}
			cout<<endl;
			if(i==2 || i==5){
			cout<<"    ----+-----+----"<<endl;
			}
		}
	}
	sudoku::int is_grid_solved(){
		for(int i=0;i<9;i++){
		for(int j=0;j<9;j++){
			if(grid[i][j]==0){
				return 0;
			}
		}
		}
		return 1;
	}
	sudoku::int is_pattern_unsolvable(){
		for(int i=0;i<9;i++){
		for(int j=0;j<9;j++){
			if(np[i][j]==0){
				return (1); // Failed Recursion - AND/OR - unsolvable sudoku!
			}
			if(!(np[i][j]>=0 || np[i][j]==-5)){
				cout<<"Fatal Error :<"<<endl;
				return (1);
			}
		}
		}
		if(checkbasicuniqueness()==0){
			cout<<"Puzzle Fails Uniqueness Tests :("<<endl;
			exit (0);
		}
		return (0);
	}
	sudoku::int checkbasicuniqueness(){
		if(checkblanks()>64 || presentnoscheck()<8){
			return (0);
		}
		return (1);
	}
	sudoku::int presentnoscheck(){
		int present[9]={0,0,0,0,0,0,0,0,0},presentnos=0;
		for(int i=0;i<9;i++){
		for(int j=0;j<9;j++){
			if(grid[i][j]!=0){
				if(present[(grid[i][j]-1)]!=1){
					present[(grid[i][j]-1)]=1;
					presentnos++;
				}
			}
		}
		}
		return presentnos;
	}
	sudoku::int checkblanks(){
		int blanks=0;
		for(int i=0;i<9;i++){
		for(int j=0;j<9;j++){
			if(grid[i][j]==0){
				blanks++;
			}
		}
		}
		return (blanks);
	}
	sudoku::int solver_solved(){
		int guessresult;
		if(is_pattern_unsolvable()){
			return 0;
		}
		logic();
		if(is_pattern_unsolvable()){
			return 0;
		}
		if(is_grid_solved()){
			if(multiple==0){
				int count=0;
				for(int i=0;i<9;i++){
				for(int j=0;j<9;j++){
					linegrid[count++]=grid[i][j]+48;
				}
				}
				linegrid[count/*=81*/]='\0';
			}
			if(multiple+1<501){
				multiple++;
				printsudoku();
				return 1;
			}
			else{
				cout<<"No. of valid possible solutions exceeds 500 :?"<<endl;
				exit (0);
			}
		}
		recsolved=1;
		guessresult=solver_guess();
		if(guessresult=1){
			correctguesses++;
		}
		else if(guessresult=0){
			failedguesses++;
		}
		else{
			cout<<"Fatal Error :<"<<endl;
			exit (0);
		}
		return guessresult;
	}
	sudoku::int solver_guess(){
		for(int i=0;i<9;i++){
		for(int j=0;j<9;j++){
			if(grid[i][j]==0){
				for(int k=0;k<9;k++){
					if(posbl[i][j][k]!=-1){
						sudoku tmp=*this;
						tmp.grid[i][j]=posbl[i][j][k];
						tmp.np[i][j]=-5;
						recursions++;
						tmp.updatedependencies(i,j,k);
						tmp.solver_solved();
					}
				}
				return 0;
			}
		}
		}
		return 0;
	}
	// exclusive to generator
	sudoku::void initblankobj(){
		for(int i=0;i<9;i++){
		for(int j=0;j<9;j++){
			grid[i][j]=0;
			np[i][j]=9;
				for(int k=0;k<9;k++){
					posbl[i][j][k]=k+1;
				}
		}
		}
		srand(time(NULL));
		for(int i=0,j=0;j<3;j++){
			while(posbl[i][j][(grid[i][j]=(rand()%9+1))-1]==-1);
			np[i][j]=-5;
			updatedependencies(i,j,grid[i][j]-1);
		}
		srand(time(NULL));
		for(int i=3,j=3;j<6;j++){
			while(posbl[i][j][(grid[i][j]=(rand()%9+1))-1]==-1);
			np[i][j]=-5;
			updatedependencies(i,j,grid[i][j]-1);
		}
		srand(time(NULL));
		for(int i=6,j=6;j<9;j++){
			while(posbl[i][j][(grid[i][j]=(rand()%9+1))-1]==-1);
			np[i][j]=-5;
			updatedependencies(i,j,grid[i][j]-1);
		}
	}
	sudoku::int hideblanks(int numblanks){
		sudoku foruser=*this;
		for(int i=0;i<9;i++){
		for(int j=0;j<9;j++){
			if(grid[i][j]!=0){
				for(int k=0;k<9;k++){
					foruser.posbl[i][j][k]=-1;
				}
				foruser.posbl[i][j][(grid[i][j]-1)]=grid[i][j];
				foruser.np[i][j]=-5;
			}
			else{
				for(int k=0;k<9;k++){
					foruser.posbl[i][j][k]=k+1;
				}
				foruser.np[i][j]=9;
			}
		}
		}
		if(is_puzzle_symmetric==1){
			numblanks=(int)(numblanks/2); // symmetrical puzzles only
		}
		for(int a=0;a<numblanks;a++){
			repeat:
			int rem1,rem2; // rem2 for symmetrical puzzles only
			srand(time(NULL));
			int i;
			if(is_puzzle_symmetric==1){
				i=rand()%5; // symmetrical puzzles only
			}
			else{
				i=rand()%9;
			}
			int j=rand()%9;
			if(i==4 && j>4 && is_puzzle_symmetric==1){
				while((j=rand()%9)>4); // symmetrical puzzles only
			}
			while(1){
				if((rem1=foruser.grid[i][j])!=0){
					foruser.grid[i][j]=0;
					if(is_puzzle_symmetric==1){	
						rem2=foruser.grid[8-i][8-j]; // symmetrical puzzles only
						foruser.grid[8-i][8-j]=0; // symmetrical puzzles only
					}
					break;
				}
				else{
					if(is_puzzle_symmetric==1){
						i=rand()%5; // symmetrical puzzles only
					}
					else{
						i=rand()%9;
					}
					j=rand()%9;
					if(i==4 && j>4 && is_puzzle_symmetric==1){
						while(j=rand()%9>4); // symmetrical puzzles only
					}
				}
			}
			recursions=0,logictimes=0,correctguesses=0,failedguesses=0,multiple=0;
			sudoku tmp=foruser;
				for(int k=0;k<9;k++){
					tmp.posbl[i][j][k]=k+1;
				}
				tmp.np[i][j]=9;
				if(is_puzzle_symmetric==1){
					for(int k=0;k<9;k++){
						tmp.posbl[8-i][8-j][k]=k+1; // symmetrical puzzles only
					}
					tmp.np[8-i][8-j]=9; // symmetrical puzzles only
				}
			tmp.solver_solved();
			if(multiple>1 || tmp.checkbasicuniqueness()==0){
				foruser.grid[i][j]=rem1; //cout<<"1 (...More...) Failed HideBlanks Operation ;("<<endl;
				if(is_puzzle_symmetric==1){
					foruser.grid[8-i][8-j]=rem2; // symmetrical puzzles only
				} // HENCE BACKTRACKING IS REQUIRED TO JUST PREVIOUS VALID GRID
				goto repeat;
			}
			else if(multiple<1){
				cout<<"Fatal Error :<"<<endl;
				exit (0);
			}
			else{ // FURTHER PROGRESSING!
				for(int k=0;k<9;k++){
					foruser.posbl[i][j][k]=k+1;
				}
				foruser.np[i][j]=9;
				if(is_puzzle_symmetric==1){
					for(int k=0;k<9;k++){
						foruser.posbl[8-i][8-j][k]=k+1; // symmetrical puzzles only
					}
					foruser.np[8-i][8-j]=9; // symmetrical puzzles only
				}
			}
		}
		sudoku check=foruser;
		check.solver_solved();
		if(foruser.checkbasicuniqueness()==1){
			if(recursions!=0 || no_guessing_reqd==1){
					cout<<"Puzzle Rating: "<<(diffscore=(int)((logictimes+failedguesses*4+correctguesses*2)*numblanks/5))<<endl;
					if(recursions!=0 && recursions!=failedguesses+correctguesses){
						cout<<recursions<<"~"<<failedguesses<<"+"<<correctguesses<<endl; // DEBUGGING CODE
					} // if(recursions!=failedguesses+correctguesses){cout<<"Unknown Error :?"<<endl;}
					foruser.printsudoku();
					return 1;
				/*else{ // NEVER OCCURS!
				cout<<"Rejected"<<endl<<diffscore<<endl;
				foruser.printsudoku();
				//return 0;
				}*/
			}
			else{
				diffscore=((logictimes+failedguesses*5+correctguesses*2)*numblanks/(float)5);
				cout<<"Rejected Due To No Recursion Being Required :(\nPuzzle Rating: "<<diffscore<<endl;
				foruser.printsudoku();
				return 0;
			}
		}
		else{
		return 0;
		}
}
	sudoku::int gen_guess(){
		for(int i=1;i<9;i++){
		for(int j=0;j<9;j++){
		if(grid[i][j]==0){
			for(int k=0;k<9;k++){
			if(posbl[i][j][k]!=-1){
			sudoku tmp=*this;
				tmp.grid[i][j]=posbl[i][j][k];
				tmp.np[i][j]=-5;
				tmp.updatedependencies(i,j,k);
				if(tmp.gen_solved()){
					*this=tmp;
					return 1;
				}
			}
			}
			return 0;
		}
		}
		}
		return 0;
	}
	sudoku::int gen_solved(){
		int guessresult;
		if(is_pattern_unsolvable()){
		return 0;
		}
		logic();
		if(is_pattern_unsolvable()){
		return 0;
		}
		if(is_grid_solved()){
		return 1;
		}
		return gen_guess();
	}
	// exclusive to solver
	sudoku::void initsolverreadyobj(){
		char line_sudoku[82],loadchoice,name[100],file[104];
		cout<<"Do you want to load a puzzle from a file (y/n)? ";
		cin>>loadchoice;
		if(loadchoice=='y'){
			cout<<"Please enter case-sensitive filename of appropriate file without extension: ";
			cin>>name;
			sprintf(file,"%s.sdk",name);
			FILE *load_sdk;
			load_sdk=fopen(file,"r");
			if(load_sdk==NULL){
				cout<<"Failed to open the file "<<file<<" :("<<endl;
				exit (0);
			}
			fgets(line_sudoku,82,load_sdk);
			goto skipmanualinput;
		}
		else if(loadchoice!='n'){
			cout<<"Arbit Nonsense!? Going for manual entry of grid :}"<<endl;
		}
		cout<<"Please input the unsolved sudoku grid in the specified format: "<<endl;
		cin>>line_sudoku;
		skipmanualinput:
		int count=0;
		for(int i=0;i<9;i++){
		for(int j=0;j<9;j++){
			grid[i][j]=line_sudoku[count++]-48;
				if(!(grid[i][j]>0 && grid[i][j]<10)){
					grid[i][j]=0;
					np[i][j]=9;
						for(int k=0;k<9;k++){
							posbl[i][j][k]=k+1;
						}
					continue;
				}
			np[i][j]=-5;
			updatedependencies(i,j,grid[i][j]-1);
		}
		}
	}
	sudoku::void printactivity(int i,int j,int value,int which=0){
		if(!(which==1 || which==2 || which==3)){
			cout<<"Plugged in "<<value<<" at ("<<i+1<<","<<j+1<<")";
		} // which is the identification no. for the logic: 1 - RCs+BOXs, 2 - NOOTHERPOSBL RC, 3 - NOOTHERPOSBL BOX
		switch(which){
			case 1:
				cout<<" by Rows/Columns/Box Elimination"<<endl;
				break;
			case 2:
				cout<<" since nowhere else possible in Rows/Columns"<<endl;
				break;
			case 3:
				cout<<" since nowhere else possible in Box"<<endl;
				break;
			default:
				cout<<"Fatal Error :<"<<endl;
				exit (1);
		}
		//cout<<endl;printsudoku();
	}
};

// exclusive to generator
int randnumblanks(int difflevel){
	int empty;
	srand(time(NULL));
	if(difflevel==2){
		no_guessing_reqd=1;
		while(1){
			if((empty=((rand()%100)/2+1))>=46){
				return empty;
			}
		}
	}
	else if(difflevel==1){
		no_guessing_reqd=1;
		while(1){
			if((empty=((rand()%100)/2-4))>=40){
				return empty;
			}
		}
	}
	else if(difflevel==3){
		no_guessing_reqd=1; // 0 consumes some minutes
		while(1){
			if((empty=((rand()%100)/2+5))>=51){
				return empty;
			}
		}
	}
	else if(difflevel==4){
		no_guessing_reqd=1; // 0 never attained in testing in acceptable time
		while(1){
			if((empty=((rand()%100)/2+11))>=55){
				return empty;
			}
		}
	}
	else{
		no_guessing_reqd=1;
		cout<<"Arbit Nonsense!? Zero Blanks Assumed - Will Give Identical Puzzle Every Run :<"<<endl;
		return 0;
	}
}
// exclusive to solver
void save_current_grid(){
	int ifilename=time(NULL);
	char sfilename[15]; // 12345678.sdk'\0' = 15 characters
	sprintf(sfilename,"%d.sdk",ifilename);
	FILE *time_sdk;
	time_sdk=fopen(sfilename,"w");
	if(time_sdk==NULL){
		cout<<"Failed to create/write the file "<<ifilename<<".sdk :("<<endl;
		return;
	}
	fputs(linegrid,time_sdk);
	fclose(time_sdk);
	cout<<"Unique solution the grid saved in "<<ifilename<<".sdk"<<endl;
	return;
}