#define GRIDSIZE 9
#define rows 3
#define columns 3
#include<iostream>
#include<cstdlib>
#include<ctime>
#include<cstdio>
#include'commmon_functions.cpp'

using namespace std;

int recursions=0,logictimes=0,diffscore=0,correctguesses=0,failedguesses=0,multiple=0,recsolved=0;
char linegrid[82];

int main(){
	sudoku main;
		main.initsolverreadyobj();
		if(main.is_pattern_unsolvable()){
			cout<<"Invalid sudoku entered..."<<endl;
			return (0);
		}
		cout<<endl<<"Unsolved Grid with "<<main.checkblanks()<<" blanks: "<<endl;
		main.decorated_sudoku();
	sudoku answer=main;
		int debug=answer.solver_solved();
		if(multiple>1 || (recsolved==1 && debug==0)){
			debug=1;
		}
		if(debug!=1){
			cout<<"Fatal Error :<"<<endl;
			return (0);
		}
		//cout<<"debug:"<<debug<<endl;
		if(multiple>0){
			if(multiple==1){
				cout<<endl<<"Exactly 1 solution found!"<<endl;
				char save;
				cout<<"Save solution in a file (y/n)? ";
				cin>>save;
				if(save=='y'){
					save_current_grid();
				}
				else if(save!='n'){
					cout<<"Arbit Nonsense!? Not Saving Grid - Copy Manually :}"<<endl;
				}
			}
			else{
				cout<<endl<<multiple<<" solutions found!"<<endl;
			}
		}
		else if(multiple==0){
			cout<<endl<<"No solution found :{"<<endl;
		}
		else{
			cout<<"Fatal Error :<"<<endl;
			return (0);
		}
	return (1);
}