#include<iostream>
#include<cstdlib>
#include<ctime>
#include<cstdio>
#include"/home/natty-ezwin/Desktop/Sudoku-CS101/after_stage1/working_directory/sudoku-algorithm-folder/sudokulib.h"
#include <ezwin.h>
#include <cassert>
#include "rect.h"
#include "bitmap.h"
using namespace std;

sudoku current;
int cellselection[9][9]; //This is used to ensure which cell is selected
int numberselection[9];	 //This is used to ensure which number is selected
int given_flag[9][9];

SimpleWindow MainAppWindow("Sudoku!", 13.0, 14, Position(1.0,1.0));
SimpleWindow MenuWindow("Menu",3.0,3.0,Position(6.0,6.25));
BitMap Cell(MainAppWindow);
 
float stepfn(float a){ //This is greatest integral function which is used in next steps
	int temp;
	temp=a;
	return temp;
}
int menumouseclick(const Position &r){
}
void menu(){
	MenuWindow.Open();
	MenuWindow.SetMouseClickCallback(menumouseclick);
}

void render_gridlines(){
	float gridx=2.0,gridy=2.0;    // here (gridx,gridy) is the left to grid x corner of the grid
	for (int i=0;i<=9;i++)
	{
		if ((i)%3==0)
		{
			MainAppWindow.RenderLine  (Position(gridx+i,gridy), Position(gridx+i,gridy+9),Black, 0.1);
			MainAppWindow.RenderLine  (Position(gridx,gridy+i), Position(gridx+9,gridy+i),Black, 0.1);
		}
		else
		{
			MainAppWindow.RenderLine  (Position(gridx+i,gridy), Position(gridx+i,gridy+9),Black, 0.0);
			MainAppWindow.RenderLine  (Position(gridx,gridy+i), Position(gridx+9,gridy+i),Black, 0.0);
		}
	}
	for(int i=0;i<=9;i++){
		MainAppWindow.RenderLine  (Position(2+i,12.0), Position(2+i,13.0),Black, 0.0);
	}
	MainAppWindow.RenderLine  (Position(2,12.0), Position(11.0,12.0),Black, 0.0);
	MainAppWindow.RenderLine  (Position(2,13.0), Position(11.0,13.0),Black, 0.0);
}
void clear_puzzle(){
	current.init_current_obj();
	for(int m=0;m<9;m++){
	for(int n=0;n<9;n++){
		Cell.Load("wblank.xpm"); Cell.SetPosition(Position(2.0+m,2.0+n)); Cell.Draw();
		render_gridlines();
		given_flag[m][n]=0;
	}
	}
}
void execute_generate_algorithm(){
	int difflevel;
	char is_symmetrical;
	cout<<"1 - Kiddie - 40 to 45 blanks"<<endl;
	cout<<"2 - Intermediate - 46 to 50 blanks"<<endl;
	cout<<"3 - Quite Tough - 51 to 54 blanks"<<endl;
	cout<<"4 - Exclusive to Pros - 55 to 60 blanks"<<endl;
	cout<<"Enter the desired difficulty level: "<<endl;
	cin>>difflevel;
	cout<<"Do you want a rotationally symmetric puzzle pleasing to the eyes? (y,n)"<<endl;
	cin>>is_symmetrical;
	if(is_symmetrical!='n'){
		if(is_symmetrical!='y'){
			cout<<"Arbit Nonsense!? Symmetry Assumed :}"<<endl;
		}
		is_puzzle_symmetric=1;
	}
	else{
		is_puzzle_symmetric=0;
	}
	generate(difflevel);
	current.line_to_grid(new_question_linegrid,current.grid);
	for(int m=0;m<9;m++){
	for(int n=0;n<9;n++){
		if(current.grid[m][n]==0){
			Cell.Load("wblank.xpm"); Cell.SetPosition(Position(2.0+m,2.0+n)); Cell.Draw();
			given_flag[m][n]=0;
		}
		else{
			current.updatedependencies(m,n,(current.grid[m][n]-1));
			char bitmap_name[10];
			sprintf(bitmap_name,"b%d.xpm",current.grid[m][n]);
			given_flag[m][n]=1;
			Cell.Load(bitmap_name); Cell.SetPosition(Position(2.0+m,2.0+n)); Cell.Draw();
		}
		render_gridlines();
	}
	}
}
void execute_solve_algorithm(){
}
void check(){
}
void display_dialog_hint(){
}
int wmouseclick(const Position &p){
	int temp_x = stepfn(p.GetXDistance());
	int temp_y = stepfn(p.GetYDistance());
	if ( ((temp_x==1)||(temp_x==2))&&((temp_y==0)||(temp_y==1)) ){
		menu();
	}
	else if ( ((temp_x==3)||(temp_x==4))&&((temp_y==0)||(temp_y==1)) ){
		execute_generate_algorithm();
	}
	else if ( ((temp_x==5)||(temp_x==6))&&((temp_y==0)||(temp_y==1)) ){
		execute_solve_algorithm();
	}
	else if ( ((temp_x==7)||(temp_x==8))&&((temp_y==0)||(temp_y==1)) ){
		check();
	}
	else if ( ((temp_x==9)||(temp_x==10))&&((temp_y==0)||(temp_y==1)) ){
		clear_puzzle();
	}
	else if( ((temp_x>=2)&&(temp_x<=11))&&((temp_y>=2)&&(temp_y<=11)) ){
		//This is to store the selected cell in grid
		for(int i=0;i<9;i++){
		for(int j=0;j<9;j++){
			if((temp_x==2+i)&&(temp_y==2+j)){
				cellselection[i][j]=1;
				if(current.grid[i][j]==0){
					Cell.Load("sblank.xpm"); Cell.SetPosition(Position(2.0+i,2.0+j)); Cell.Draw();
				}
				else{
					char bitmap_name[10];
					sprintf(bitmap_name,"s%d.xpm",current.grid[i][j]);
					Cell.Load(bitmap_name); Cell.SetPosition(Position(2.0+i,2.0+j)); Cell.Draw();
				}
				render_gridlines();
			}
			else{
				if(cellselection[i][j]==1){
					if(current.grid[i][j]==0){
						Cell.Load("wblank.xpm"); Cell.SetPosition(Position(2.0+i,2.0+j)); Cell.Draw();
					}
					else{
						char bitmap_name[10];
						if(given_flag[i][j]==1){
						sprintf(bitmap_name,"b%d.xpm",current.grid[i][j]);
						}
						else{
						sprintf(bitmap_name,"w%d.xpm",current.grid[i][j]);
						}
						Cell.Load(bitmap_name); Cell.SetPosition(Position(2.0+i,2.0+j)); Cell.Draw();
					}
					render_gridlines();
					cellselection[i][j]=0;
				}
			}
		}
		}
	}

	if(temp_y==12)
	{	
		for(int i=0;i<9;i++)//This is to store which number is selected
		{
			if (temp_x==2+i)
				{
				numberselection[i]=1;
				}
			else numberselection[i]=0;

		}
		for (int k=0;k<9;k++){
			if(numberselection[k]==1){
				for (int i=0;i<9;i++){
				for (int j=0;j<9;j++){
					if(cellselection[i][j]==1 && given_flag[i][j]==0){
						if(current.posbl[i][j][k]!=-1){
							char bitmap_name[10];
							sprintf(bitmap_name,"s%d.xpm",(k+1));	
							Cell.Load(bitmap_name); Cell.SetPosition(Position(2.0+i,2.0+j)); Cell.Draw();
							current.grid[i][j]=k+1;
							current.np[i][j]=-5;
							for(int l=0;l<9;l++){
									current.posbl[i][j][l]=-1;
							}
							current.posbl[i][j][k]=k+1;
							current.updatedependencies(i,j,k);
							current.decorated_sudoku(); // debugging
							render_gridlines();
						}
						else{
						// GUI ALERT
						}
					}
				}
				}
			}
		}
	}

}
void window_grid_start(){ //a 9x9 grid is generated and numbers are shown which are to be clicked for choosing
	float gridx=2.0,gridy=2.0;    //here (gridx,gridy) is the left togridx corner of the grid  
	MainAppWindow.Open(); assert( MainAppWindow.GetStatus() == WindowOpen );
	for(int i=0;i<9;i++){	
		numberselection[i]=0;
		for(int j=0;j<9;j++){
			cellselection[i][j]=0;
		}
	}
	//The following steps are for printing numbers
	Cell.Load("w1.xpm");Cell.SetPosition(Position(2.0,12.0)) ;Cell.Draw();
	Cell.Load("w2.xpm");Cell.SetPosition(Position(3.0,12.0)) ;Cell.Draw();
	Cell.Load("w3.xpm");Cell.SetPosition(Position(4.0,12.0)) ;Cell.Draw();
	Cell.Load("w4.xpm");Cell.SetPosition(Position(5.0,12.0)) ;Cell.Draw();
	Cell.Load("w5.xpm");Cell.SetPosition(Position(6.0,12.0)) ;Cell.Draw();
	Cell.Load("w6.xpm");Cell.SetPosition(Position(7.0,12.0)) ;Cell.Draw();
	Cell.Load("w7.xpm");Cell.SetPosition(Position(8.0,12.0)) ;Cell.Draw();
	Cell.Load("w8.xpm");Cell.SetPosition(Position(9.0,12.0)) ;Cell.Draw();
	Cell.Load("w9.xpm");Cell.SetPosition(Position(10.0,12.0)) ;Cell.Draw();
	render_gridlines();
	for (int i=-2;i<=6;i+=2){
		MainAppWindow.RenderLine  (Position(3.0+i,0.5), Position(5.0+i,0.5),Black, 0.0);
		MainAppWindow.RenderLine  (Position(3.0+i,1.5), Position(5.0+i,1.5),Black, 0.0);
		MainAppWindow.RenderLine  (Position(3.0+i,0.5), Position(3.0+i,1.5),Black, 0.0);
		MainAppWindow.RenderLine  (Position(5.0+i,0.5), Position(5.0+i,1.5),Black, 0.0);
	}
	MainAppWindow.RenderText(Position(3.0-2,0.5),Position(5.0-2,1.5),"Menu",Black);sleep(0);
	MainAppWindow.RenderText(Position(3.0,0.5),Position(5.0,1.5),"Generate",Black);sleep(0);
	MainAppWindow.RenderText(Position(3.0+2,0.5),Position(5.0+2,1.5),"Solve",Black);sleep(0);
	MainAppWindow.RenderText(Position(3.0+4,0.5),Position(5.0+4,1.5),"Check",Black);sleep(0);
	MainAppWindow.RenderText(Position(3.0+6,0.5),Position(5.0+6,1.5),"Clear",Black);sleep(0);
	MainAppWindow.SetMouseClickCallback(wmouseclick);
}
int ApiMain(){
	current.init_current_obj();
	window_grid_start();
	return (0);
}